﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.OpenAccess;
using NorthwindModel;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;

namespace ContainerCreator
{
    class Program
    {
        static void Main(string[] args)
        {
            if (args.Length != 1)
                throw new Exception("Please add only the connection string as parameter");
            string connectionString = args[0];

            NorthwindContext context = new NorthwindContext(connectionString);
            ObjectContainer container = new ObjectContainer();
            container.CopyFrom(context.Scope, "dummy", context.GetAll<Category>(), new FetchGroupCollector(FetchGroupCollector.DefaultFetchGroup));
            container.CopyFrom(context.Scope, "dummy", context.GetAll<Customer>(), new FetchGroupCollector(FetchGroupCollector.DefaultFetchGroup));
            container.CopyFrom(context.Scope, "dummy", context.GetAll<CustomerDemographic>(), new FetchGroupCollector(FetchGroupCollector.DefaultFetchGroup));
            container.CopyFrom(context.Scope, "dummy", context.GetAll<Employee>(), new FetchGroupCollector(FetchGroupCollector.DefaultFetchGroup));
            container.CopyFrom(context.Scope, "dummy", context.GetAll<Order>(), new FetchGroupCollector(FetchGroupCollector.DefaultFetchGroup));
            container.CopyFrom(context.Scope, "dummy", context.GetAll<OrderDetail>(), new FetchGroupCollector(FetchGroupCollector.DefaultFetchGroup));
            container.CopyFrom(context.Scope, "dummy", context.GetAll<Product>(), new FetchGroupCollector(FetchGroupCollector.DefaultFetchGroup));
            container.CopyFrom(context.Scope, "dummy", context.GetAll<Region>(), new FetchGroupCollector(FetchGroupCollector.DefaultFetchGroup));
            container.CopyFrom(context.Scope, "dummy", context.GetAll<Shipper>(), new FetchGroupCollector(FetchGroupCollector.DefaultFetchGroup));
            container.CopyFrom(context.Scope, "dummy", context.GetAll<Supplier>(), new FetchGroupCollector(FetchGroupCollector.DefaultFetchGroup));
            container.CopyFrom(context.Scope, "dummy", context.GetAll<Territory>(), new FetchGroupCollector(FetchGroupCollector.DefaultFetchGroup));

            var changeSet = container.GetContent();
            Stream stream = File.Open("NorthwindContainer.serialized", FileMode.Create);
            BinaryFormatter bFormatter = new BinaryFormatter();
            bFormatter.Serialize(stream, changeSet);
            stream.Close();
        }
    }
}
